#!/usr/bin/env python3

'''
This script demonstrates encrypting a piece of message using AES-CBC and then
decrypting it.

DO NOT hardcode your key and iv!
'''

from Crypto.Cipher import AES
from Crypto.Util.Padding import pad, unpad

# 128-bit key, which is 16 bytes (32 hex chars)
KEY = "abcdeabcdeabcdeabcdeabcdeabcde01"
# 128-bit IV
IV = "012345678901234567890123456789ab"

def key_iv_format_checker(key, iv):
    '''Check if the key and iv have a legit length'''
    if len(key) not in {16, 24, 32}:
        raise ValueError("Key must be 16, 24, or 32 bytes long.")
    if len(iv) != 16:
        raise ValueError("IV must be 16 bytes long.")

def encrypt(msg):
    cipher = AES.new(bytes.fromhex(KEY), AES.MODE_CBC, bytes.fromhex(IV))

    encyrpted_msg = cipher.encrypt(msg, AES.block_size)

    print("Encrypted message: " + encyrpted_msg.hex())

    return encyrpted_msg

def decrypt(msg):
    cipher = AES.new(bytes.fromhex(KEY), AES.MODE_CBC, bytes.fromhex(IV))

    decrypted_msg = unpad(cipher.decrypt(msg), AES.block_size)

    print("Decrypted message: " + decrypted_msg.decode())

if __name__ == "__main__":
    key_iv_format_checker(KEY, iv)

    msg = "Hello from GWU CSCI4531/6531!"

    encyrpted_msg = encrypt(msg.encode())

    decrypt(encyrpted_msg)
